/* Generated By:JavaCC: Do not edit this line. Rules.java */
package dk.dtu.compute.se2.rules.parser;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;

import dk.dtu.compute.se2.rules.*;

public class Rules implements RulesConstants {

    private static final RulesFactory RULESFACTORY = RulesFactory.eINSTANCE;

    public List<Rule> parse() {
        try {
            return RULES();
        } catch (TokenMgrError e) {
                // TODO do some reasonable error handling here
            return null;
        } catch (ParseException e) {
            // TODO do some reasonable error handling here
            return null;
        }
    }

    // just for test purposes
    public static void main(String[] args) {
        try {
                Rules parser = new Rules(System.in);
                List<Rule> rules = parser.RULES();

                System.out.println("Syntax is okay");
                System.out.println(rules.size() + " rules parsed");

                // Print out the structure (AST) of the parsed rules
                for (Rule rule: rules) {
                        print(rule);
                        System.out.println();
                }
        } catch (Throwable e) {
                System.out.println("Parse error: " + e.getMessage());
        }
    }

    // just for test purposes
    public static void print(Rule rule) {
        Iterator<EObject> iterator = rule.eAllContents();
        Map<EObject,Integer> ids = new HashMap<EObject,Integer>();
        int count = 0;
        System.out.println("Rule " + rule.getName() +":");
        while (iterator.hasNext()) {
                Object object = iterator.next();
                if (object instanceof EObject) {
                        EObject eObject = (EObject) object;
                        Integer id = ids.get(eObject);
                        if (id == null) {
                                id = ++count;
                                ids.put(eObject,count);
                        }
                        System.out.println(id +": (class: " + eObject.eClass().getName() + ")");
                        for (EAttribute attribute: eObject.eClass().getEAllAttributes()) {
                                System.out.println("  " + attribute.getName() +": " + eObject.eGet(attribute));
                        }
                        for (EReference reference: eObject.eClass().getEAllReferences()) {
                                if (!reference.isContainment()) {
                                        EObject target = (EObject) eObject.eGet(reference);
                                        if (target != null) {
                                                Integer targetId = ids.get(target);
                                                if (targetId == null) {
                                                        targetId = ++count;
                                                        ids.put(eObject, targetId);
                                                }
                                                System.out.println("  " + reference.getName() +": " + targetId);
                                        }
                                }
                        }
                }
        }
    }

// Token related rules (conversion to objects):
  final public String IDENTIFIER() throws ParseException {
        Token identifierToken;
    identifierToken = jj_consume_token(IDENTIFIER);
          {if (true) return identifierToken.image;}
    throw new Error("Missing return statement in function");
  }

  final public int NUMBER() throws ParseException {
        Token numberToken;
    numberToken = jj_consume_token(NUMBER);
          {if (true) return Integer.parseInt(numberToken.image);}
    throw new Error("Missing return statement in function");
  }

  final public OP OP0() throws ParseException {
    jj_consume_token(21);
                 {if (true) return OP.OR;}
    throw new Error("Missing return statement in function");
  }

  final public OP OP1() throws ParseException {
    jj_consume_token(9);
                 {if (true) return OP.AND;}
    throw new Error("Missing return statement in function");
  }

  final public OP OP2() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 11:
      jj_consume_token(11);
                  {if (true) return OP.EQUAL;}
      break;
    case 10:
      jj_consume_token(10);
              {if (true) return OP.GTEQUAL;}
      break;
    default:
      jj_la1[0] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

// Actual grammar rules:  
  final public List<Rule> RULES() throws ParseException {
        List<Rule> rules = new ArrayList<Rule>();
        Rule rule;
    label_1:
    while (true) {
      rule = RULE();
      jj_consume_token(13);
                          rules.add(rule);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[1] = jj_gen;
        break label_1;
      }
    }
    jj_consume_token(0);
      {if (true) return rules;}
    throw new Error("Missing return statement in function");
  }

  final public Rule RULE() throws ParseException {
        String identifier;
        Event event;
        Expression condition;
        List<Action> actions;
    identifier = IDENTIFIER();
    jj_consume_token(14);
    jj_consume_token(16);
    event = EVENT();
    jj_consume_token(17);
    condition = EXPRESSION();
    jj_consume_token(18);
    actions = ACTIONS();
          Rule rule = RULESFACTORY.createRule();
      rule.setName(identifier);
          rule.setEvent(event);
          rule.setCondition(condition);
          rule.getActions().addAll(actions);
          {if (true) return rule;}
    throw new Error("Missing return statement in function");
  }

  final public Event EVENT() throws ParseException {
        String identifier;
    identifier = IDENTIFIER();
          Event event = RULESFACTORY.createEvent();
          event.setType(identifier);
          {if (true) return event;}
    throw new Error("Missing return statement in function");
  }

  final public Expression EXPRESSION() throws ParseException {
        Expression expression;
    expression = EXPRESSION0();
          {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

  final public Expression EXPRESSION0() throws ParseException {
        Expression expression1;
        Expression expression2;
        OP operator;
    expression1 = EXPRESSION1();
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 21:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_2;
      }
      operator = OP0();
      expression2 = EXPRESSION1();
        Operation operation = RULESFACTORY.createOperation();
        operation.setOp(operator);
        operation.getOperands().add(expression1);
        operation.getOperands().add(expression2);
        expression1 = operation;
    }
          {if (true) return expression1;}
    throw new Error("Missing return statement in function");
  }

  final public Expression EXPRESSION1() throws ParseException {
        Expression expression1;
        Expression expression2;
        OP operator;
    expression1 = EXPRESSION2();
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 9:
        ;
        break;
      default:
        jj_la1[3] = jj_gen;
        break label_3;
      }
      operator = OP1();
      expression2 = EXPRESSION2();
        Operation operation = RULESFACTORY.createOperation();
        operation.setOp(operator);
        operation.getOperands().add(expression1);
        operation.getOperands().add(expression2);
        expression1 = operation;
    }
          {if (true) return expression1;}
    throw new Error("Missing return statement in function");
  }

  final public Expression EXPRESSION2() throws ParseException {
        Expression expression1;
        Expression expression2;
        OP operator;
    expression1 = ATOMIC();
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 10:
      case 11:
        ;
        break;
      default:
        jj_la1[4] = jj_gen;
        break label_4;
      }
      operator = OP2();
      expression2 = ATOMIC();
        Operation operation = RULESFACTORY.createOperation();
        operation.setOp(operator);
        operation.getOperands().add(expression1);
        operation.getOperands().add(expression2);
        expression1 = operation;
    }
          {if (true) return expression1;}
    throw new Error("Missing return statement in function");
  }

  final public Expression ATOMIC() throws ParseException {
        Expression expression;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 6:
      jj_consume_token(6);
      expression = EXPRESSION();
      jj_consume_token(7);
                                              {if (true) return expression;}
      break;
    case IDENTIFIER:
      expression = ATTRIBUTE();
                                    {if (true) return expression;}
      break;
    case NUMBER:
      expression = CONSTANT();
                                    {if (true) return expression;}
      break;
    default:
      jj_la1[5] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public Attribute ATTRIBUTE() throws ParseException {
        String object;
        String slot;
    object = IDENTIFIER();
    jj_consume_token(12);
    slot = IDENTIFIER();
          Attribute attribute = RULESFACTORY.createAttribute();
          attribute.setObject(object);
          attribute.setSlot(slot);
          {if (true) return attribute;}
    throw new Error("Missing return statement in function");
  }

  final public Constant CONSTANT() throws ParseException {
        int constantValue;
    constantValue = NUMBER();
          Constant constant = RULESFACTORY.createConstant();
          constant.setValue(constantValue);
          {if (true) return constant;}
    throw new Error("Missing return statement in function");
  }

  final public List<Action> ACTIONS() throws ParseException {
        List<Action> actions = new ArrayList<Action>();
        Action action;
    action = ACTION();
                          actions.add(action);
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 15:
        ;
        break;
      default:
        jj_la1[6] = jj_gen;
        break label_5;
      }
      jj_consume_token(15);
      action = ACTION();
                               actions.add(action);
    }
      {if (true) return actions;}
    throw new Error("Missing return statement in function");
  }

  final public Action ACTION() throws ParseException {
        String actorName;
        String actionName;
        List<Expression> parameters;
    actorName = IDENTIFIER();
    jj_consume_token(12);
    actionName = IDENTIFIER();
    parameters = PARAMETERS();
          ActorAction action = RULESFACTORY.createActorAction();
          action.setName(actionName);
          action.setActor(actorName);
          action.getParameters().addAll(parameters);
          {if (true) return action;}
    throw new Error("Missing return statement in function");
  }

  final public List<Expression> PARAMETERS() throws ParseException {
        List<Expression> parameters = new ArrayList<Expression>();
        Expression parameter;
    jj_consume_token(6);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 6:
    case IDENTIFIER:
    case NUMBER:
      parameter = EXPRESSION();
                                         parameters.add(parameter);
      label_6:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 15:
          ;
          break;
        default:
          jj_la1[7] = jj_gen;
          break label_6;
        }
        jj_consume_token(15);
        parameter = EXPRESSION();
                                               parameters.add(parameter);
      }
      break;
    default:
      jj_la1[8] = jj_gen;
      ;
    }
    jj_consume_token(7);
          {if (true) return parameters;}
    throw new Error("Missing return statement in function");
  }

  /** Generated Token Manager. */
  public RulesTokenManager token_source;
  SimpleCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[9];
  static private int[] jj_la1_0;
  static {
      jj_la1_init_0();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0xc00,0x80000,0x200000,0x200,0xc00,0x180040,0x8000,0x8000,0x180040,};
   }

  /** Constructor with InputStream. */
  public Rules(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public Rules(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new RulesTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
  }

  /** Constructor. */
  public Rules(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new RulesTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
  }

  /** Constructor with generated Token Manager. */
  public Rules(RulesTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(RulesTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List<int[]> jj_expentries = new java.util.ArrayList<int[]>();
  private int[] jj_expentry;
  private int jj_kind = -1;

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[22];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 9; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 22; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

}
